--- old/usr/src/uts/common/fs/tmpfs/tmp_dir.c	2016-12-05 21:50:23.031978149 +0000
+++ new/usr/src/uts/common/fs/tmpfs/tmp_dir.c	2016-12-05 21:50:23.044513391 +0000
@@ -21,10 +21,10 @@
 /*
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2016 RackTop Systems.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/sysmacros.h>
@@ -487,6 +487,13 @@
 	if (tp != tnp)
 		return (ENOENT);
 
+	/*
+	 * If we are unlinking a directory which isn't empty (it has
+	 * more than the minumum '.' and '..' entries) return EEXIST.
+	 */
+	if (tp->tn_type == VDIR && tp->tn_dirents > 2)
+		return (EEXIST);
+
 	tmpfs_hash_out(tpdp);
 
 	/*
@@ -527,7 +534,7 @@
 
 	ASSERT(tp->tn_nlink > 0);
 	DECR_COUNT(&tp->tn_nlink, &tp->tn_tlock);
-	if (op == DR_RMDIR && tp->tn_type == VDIR) {
+	if (tp->tn_type == VDIR) {
 		tdirtrunc(tp);
 		ASSERT(tp->tn_nlink == 0);
 	}
